// ****************************************************************************
// copyright (c) 2000-2002 Horst Knorr <hk_classes@knoda.org>
// This file is part of the hk_kdeclasses library.
// This file may be distributed and/or modified under the terms of the
// GNU Library Public License version 2 as published by the Free Software
// Foundation and appearing in the file LGPL included in the
// packaging of this file.
// This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
// WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// ****************************************************************************
#ifndef HK_KDEFORMDATASOURCEDIALOG_H
#define HK_KDEFORMDATASOURCEDIALOG_H
#include "hk_kdeformdatasourcedialogbase.h"
class hk_presentation;
class hk_datasource;
class hk_kdeformdatasourcedialog : public hk_kdeformdatasourcebasedialog
{
    Q_OBJECT

        public:
        hk_kdeformdatasourcedialog( hk_presentation* form, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
        ~hk_kdeformdatasourcedialog();
        void set_datasource(hk_datasource*);
	enum enum_displaytype{d_form,d_report};
	void set_displaytype(enum_displaytype);

    protected slots:
        virtual void add_dependingfields();
        virtual void delete_dependingfields();
        virtual void datasource_selected();
        virtual void set_datasourcelist();
        virtual void dependingon_selected();
        virtual void check_buttons();
        virtual void delete_datasource();
        virtual void new_datasource(void);

    private:
        void alter_datasource(void);
        void set_datasourceinfos(bool existingdatasource);
        hk_presentation* p_presentation;
        hk_datasource* p_datasource;
        void set_formdatasources();
	enum_displaytype p_displaytype;

};
#endif                                            // HK_KDEFORMDATASOURCEDIALOG_H
